searchData={"items":[{"type":"module","title":"Dpos","doc":"Documentation for Dpos.","ref":"Dpos.html"},{"type":"module","title":"Dpos.Crypto.Ed25519","doc":"Wrap crypto erlang functions to work with ED25519","ref":"Dpos.Crypto.Ed25519.html"},{"type":"function","title":"Dpos.Crypto.Ed25519.seed_keypair/1","doc":"","ref":"Dpos.Crypto.Ed25519.html#seed_keypair/1"},{"type":"function","title":"Dpos.Crypto.Ed25519.sign/2","doc":"","ref":"Dpos.Crypto.Ed25519.html#sign/2"},{"type":"function","title":"Dpos.Crypto.Ed25519.verify_detached/3","doc":"","ref":"Dpos.Crypto.Ed25519.html#verify_detached/3"},{"type":"module","title":"Dpos.Net","doc":"Provides functions to broadcast transactions through a relay node.","ref":"Dpos.Net.html"},{"type":"function","title":"Dpos.Net.broadcast/2","doc":"Broadcasts the transaction through a relay node.\n\nThe transaction must be already normalized.","ref":"Dpos.Net.html#broadcast/2"},{"type":"type","title":"Dpos.Net.network/0","doc":"","ref":"Dpos.Net.html#t:network/0"},{"type":"module","title":"Dpos.Time","doc":"Provides functions to work with Lisk timestamps.","ref":"Dpos.Time.html"},{"type":"function","title":"Dpos.Time.at/1","doc":"Converts a Lisk timestamp to `DateTime`.","ref":"Dpos.Time.html#at/1"},{"type":"function","title":"Dpos.Time.now/0","doc":"Returns the current Lisk timestamp.","ref":"Dpos.Time.html#now/0"},{"type":"behaviour","title":"Dpos.Tx","doc":"Define behaviour and implement functions to work with transactions.","ref":"Dpos.Tx.html"},{"type":"function","title":"Dpos.Tx.build/2","doc":"Builds a new transaction.","ref":"Dpos.Tx.html#build/2"},{"type":"function","title":"Dpos.Tx.ensure_timestamp/1","doc":"Ensure transaction has a correct timestamp value.\n\nCheck if timestamp is present and not negative,\notherwise it will be set to `Dpos.Time.now/0`.","ref":"Dpos.Tx.html#ensure_timestamp/1"},{"type":"callback","title":"Dpos.Tx.get_child_bytes/1","doc":"","ref":"Dpos.Tx.html#c:get_child_bytes/1"},{"type":"function","title":"Dpos.Tx.normalize/1","doc":"","ref":"Dpos.Tx.html#normalize/1"},{"type":"function","title":"Dpos.Tx.sign/3","doc":"Signs the transaction with the sender private key.\n\nIt accepts either a `Dpos.Wallet` or a `{\"secret\", \"L\"}` tuple as second argument\nwhere the first element is the secret and the second element is the address suffix\n(i.e. `\"L\"` for Lisk).\n\nA secondary private_key can also be provided as third argument.","ref":"Dpos.Tx.html#sign/3"},{"type":"callback","title":"Dpos.Tx.type_id/0","doc":"","ref":"Dpos.Tx.html#c:type_id/0"},{"type":"type","title":"Dpos.Tx.t/0","doc":"","ref":"Dpos.Tx.html#t:t/0"},{"type":"type","title":"Dpos.Tx.wallet_or_secret/0","doc":"","ref":"Dpos.Tx.html#t:wallet_or_secret/0"},{"type":"module","title":"Dpos.Tx.Delegate","doc":"A transaction to register a delegate.\n\nExample:\n\n```\nTx.Delegate\n|> Tx.build(%{fee: 2500000000})\n|> Tx.Delegate.set_delegate(\"genesis_1\")\n|> Tx.sign(wallet)\n```","ref":"Dpos.Tx.Delegate.html"},{"type":"function","title":"Dpos.Tx.Delegate.set_delegate/2","doc":"Sets the delegate username to be registered.","ref":"Dpos.Tx.Delegate.html#set_delegate/2"},{"type":"module","title":"Dpos.Tx.MultiSig","doc":"A Multi Sig transaction.\n\nExample:\n\n```\nTx.MultiSig\n|> Tx.build(%{fee: 2000000000, timestamp: 73056420})\n|> Tx.MultiSig.set_lifetime(3600)\n|> Tx.MultiSig.set_min(2)\n|> Tx.MultiSig.add_public_key(\"6267e1754d4b29cae9007fc0b3f0d435f981c90f70281ce053cb1c2243b848a2\")\n|> Tx.MultiSig.add_public_key(\"0bc54404ef644519592568687d2bc62593b912a57df319062bb7611b11009ebf\")\n|> Tx.MultiSig.add_public_key(\"b65aa5950acf1ade522bcf520f2b2491dcde2f312b4933f56443faff80ad8ebc\")\n|> Tx.sign(wallet)\n```","ref":"Dpos.Tx.MultiSig.html"},{"type":"function","title":"Dpos.Tx.MultiSig.add_public_key/2","doc":"Adds a public key to the keysgroup field of the multisignature.","ref":"Dpos.Tx.MultiSig.html#add_public_key/2"},{"type":"function","title":"Dpos.Tx.MultiSig.set_lifetime/2","doc":"Sets the lifetime in seconds of the multisignature.\n\nThe lifetime must be >= 3600 and <= 259200.","ref":"Dpos.Tx.MultiSig.html#set_lifetime/2"},{"type":"function","title":"Dpos.Tx.MultiSig.set_min/2","doc":"Sets the minimum number of signatures required to validate a transaction.\n\nThe minimum possible value is 2.","ref":"Dpos.Tx.MultiSig.html#set_min/2"},{"type":"module","title":"Dpos.Tx.Normalized","doc":"Normalized transaction data structure to be broadcasted via a relay node.","ref":"Dpos.Tx.Normalized.html"},{"type":"function","title":"Dpos.Tx.Normalized.normalize/1","doc":"Normalizes the transaction in a format that it could be broadcasted through a relay node.","ref":"Dpos.Tx.Normalized.html#normalize/1"},{"type":"type","title":"Dpos.Tx.Normalized.t/0","doc":"","ref":"Dpos.Tx.Normalized.html#t:t/0"},{"type":"module","title":"Dpos.Tx.SecondSignature","doc":"A transaction to register a secondary public key to sign transactions.\n\nExample:\n\n```\nwallet = Wallet.generate(\"first secret\")\n%{pub_key: second_pub_key} = Wallet.generate(\"second secret\")\n\nTx.SecondSignature\n|> Tx.build(%{fee: 2500000000})\n|> Tx.SecondSignature.set_public_key(second_pub_key)\n|> Tx.sign(wallet)\n```","ref":"Dpos.Tx.SecondSignature.html"},{"type":"function","title":"Dpos.Tx.SecondSignature.set_public_key/2","doc":"Sets the public key to register for second signature.","ref":"Dpos.Tx.SecondSignature.html#set_public_key/2"},{"type":"module","title":"Dpos.Tx.Send","doc":"A transaction to send crypto to an other recipient.\n\nExample:\n\n```\nTx.Send\n|> Tx.build(%{amount: 8840, fee: 100})\n|> Tx.sign(wallet)\n```","ref":"Dpos.Tx.Send.html"},{"type":"module","title":"Dpos.Tx.Vote","doc":"A transaction to vote or unvote delegates.\n\nExample:\n\n```\nTx.Vote\n|> Tx.build(%{fee: 100000000, recipient: \"16313739661670634666L\"})\n|> Tx.Vote.vote(\"01389197bbaf1afb0acd47bbfeabb34aca80fb372a8f694a1c0716b3398db746\")\n|> Tx.sign(wallet)\n|> Tx.normalize()\n```","ref":"Dpos.Tx.Vote.html"},{"type":"function","title":"Dpos.Tx.Vote.unvote/2","doc":"Adds the delegate's public key to unvote.","ref":"Dpos.Tx.Vote.html#unvote/2"},{"type":"function","title":"Dpos.Tx.Vote.vote/2","doc":"Adds the delegate's public key to vote.","ref":"Dpos.Tx.Vote.html#vote/2"},{"type":"module","title":"Dpos.Utils","doc":"Utility functions for DPoS.","ref":"Dpos.Utils.html"},{"type":"function","title":"Dpos.Utils.address_to_binary/2","doc":"Converts the wallet address to binary.","ref":"Dpos.Utils.html#address_to_binary/2"},{"type":"function","title":"Dpos.Utils.derive_address/2","doc":"Derives a wallet address from the public key.","ref":"Dpos.Utils.html#derive_address/2"},{"type":"function","title":"Dpos.Utils.hexdigest/1","doc":"Encodes the binary in base 16.\n\nReturns nil if binary is nil.","ref":"Dpos.Utils.html#hexdigest/1"},{"type":"function","title":"Dpos.Utils.reverse_binary/1","doc":"Reverses the given binary (from little-endian to big-endian).","ref":"Dpos.Utils.html#reverse_binary/1"},{"type":"function","title":"Dpos.Utils.seed_keypair/1","doc":"Seed a keypair from a secret key.","ref":"Dpos.Utils.html#seed_keypair/1"},{"type":"function","title":"Dpos.Utils.sign_message/2","doc":"Signs a message and returns the signature.","ref":"Dpos.Utils.html#sign_message/2"},{"type":"function","title":"Dpos.Utils.signature_to_binary/1","doc":"Ensures signature is a binary 64 bytes long.\n\nReturns an empty binary if signature is nil.","ref":"Dpos.Utils.html#signature_to_binary/1"},{"type":"function","title":"Dpos.Utils.verify_message/3","doc":"Verifies a message.","ref":"Dpos.Utils.html#verify_message/3"},{"type":"module","title":"Dpos.Wallet","doc":"The wallet struct.\nHolds the private key, public key, address and suffix length.","ref":"Dpos.Wallet.html"},{"type":"function","title":"Dpos.Wallet.generate/2","doc":"Returns a `Dpos.Tx.Wallet` struct.","ref":"Dpos.Wallet.html#generate/2"},{"type":"function","title":"Dpos.Wallet.generate_lisk/1","doc":"Alias for `generate(secret, \"L\")`.","ref":"Dpos.Wallet.html#generate_lisk/1"},{"type":"function","title":"Dpos.Wallet.generate_shift/1","doc":"Alias for `generate(secret, \"S\")`.","ref":"Dpos.Wallet.html#generate_shift/1"},{"type":"function","title":"Dpos.Wallet.sign_message/2","doc":"Signs a message using the wallet private key.\nReturns the signature.","ref":"Dpos.Wallet.html#sign_message/2"},{"type":"function","title":"Dpos.Wallet.verify_message/3","doc":"Verifies a message using its signature and the wallet public key.","ref":"Dpos.Wallet.html#verify_message/3"},{"type":"type","title":"Dpos.Wallet.t/0","doc":"","ref":"Dpos.Wallet.html#t:t/0"},{"type":"extras","title":"DPoS","doc":"# DPoS\n\nAn Elixir port of vekexasia's [dpos-offline](https://www.npmjs.com/package/dpos-offline) typescript library.","ref":"readme.html"},{"type":"extras","title":"Installation - DPoS","doc":"Add DPoS to your `mix.exs`\n\n```elixir\ndef deps do\n  [\n    {:dpos, \"~> 0.3.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - DPoS","doc":"**Wallet utilities**\n\n```elixir\nsecret = \"my secret\"\n\n# For Lisk\nlisk_wallet = Wallet.generate_lisk(secret)\n\n# For Shift\nshift_wallet = Wallet.generate_shift(secret)\n\n# For any lisk-like wallet\nwallet = Wallet.generate(secret, \"XYZ\")\n\n# Wallet struct\n%Wallet{\n  address: \"2340651171948227443XYZ\",\n  priv_key: <<185, 209, 208, 19, 246, 0, 236, 27, 241, 107, 174, 106, 54, 52,\n    202, 209, 93, 204, 73, 12, 159, 40, 53, 118, 66, 1, 164, 26, 29, 112, 222,\n    68>>,\n  pub_key: <<249, 101, 174, 176, 6, 137, 118, 4, 103, 241, 92, 60, 161, 68, 190,\n    100, 196, 154, 35, 122, 177, 234, 113, 116, 109, 35, 81, 173, 215, 138, 11,\n    101>>\n}\n\n# Sign a message\niex> {:ok, signature} = Wallet.sign_message(wallet, \"My Signed Message\")\n\n# Verify a message\niex> :ok = Wallet.verify_message(wallet, \"My Signed Message\", signature)\n```\n\n**Transaction utilities**\n\n```elixir\ntx =\n  Tx.Send\n  |> Tx.build(%{amount: 10_000_000_000, fee: 10_000_000, recipient: \"2340651171948227443XYZ\"})\n  |> Tx.sign(wallet)\n\n# Optional: signing the tx using a second private key\nTx.sign(tx, wallet, second_priv_key)\n\n# It is possible to pass a secret/suffix tuple as second argument to Tx.sign/3:\nTx.sign(tx, {\"my secret\", \"L\"})\n\n# Finally we can broadcast our transaction to a remote node (or a local node)\nnetwork = [\n  nethash: \"ed14889723f24ecc54871d058d98ce91ff2f973192075c0155ba2b7b70ad2511\",\n  version: \"1.5.0\",\n  uri: \"http://127.0.0.1:8000\"\n]\n\ntx\n|> Tx.normalize()\n|> Net.broadcast(network)\n\n# The transaction can be normalized to be easier to read and to be broadcasted to a remote node\nTx.normalize(tx)\n\n# Normalized Tx struct\n%Tx.Normalized{\n  id: \"14577272354830356516\",\n  recipientId: \"2340651171948227443XYZ\",\n  senderPublicKey: \"f965aeb00689760467f15c3ca144be64c49a237ab1ea71746d2351add78a0b65\",\n  signature: \"271d56c46e49d9b01707ba7ec90ea69a59a9e6f606abf532315e5e2fa327b465e9d9f4ef6c37d11ca84aec61f8b138881b9afa92ba39123dc6622057ea53f50f\",\n  signSignature: nil,\n  timestamp: 252848803,\n  type: 0,\n  amount: 10000000000,\n  asset: %{},\n  fee: 10000000\n}\n```","ref":"readme.html#usage"},{"type":"extras","title":"Custom Transactions - DPoS","doc":"You can implement the `Dpos.Tx` behaviour in order to create your own transaction types.\n\nThe behaviour requires you to implement 2 functions, `type_id/0` and `get_child_bytes/1`.\n\nExample:\n\n```elixir\ndefmodule MyApp.Transaction do\n  @behaviour Dpos.Tx\n\n  @impl Dpos.Tx\n  def type_id do\n    # The integer value that will be used in the `type` field.\n    3333\n  end\n\n  @impl Dpos.Tx\n  def get_child_bytes(%Tx{}) do\n    # This function must return a binary.\n    #\n    # If your transaction uses custom fields you'd need to implement a logic to compute these fields,\n    # otherwise return an empty binary.\n    #\n    # See `Dpos.Tx.Vote` for your reference.\n  end\nend\n\n```","ref":"readme.html#custom-transactions"},{"type":"extras","title":"Contributing - DPoS","doc":"Clone the repository and run `$ mix test` to make sure everything is working.","ref":"readme.html#contributing"},{"type":"extras","title":"Authors - DPoS","doc":"* **Stefano Gessa** - [sgessa](https://github.com/sgessa)","ref":"readme.html#authors"},{"type":"extras","title":"License - DPoS","doc":"DPoS is released under the MIT license. See the [license file](LICENSE.txt).","ref":"readme.html#license"},{"type":"extras","title":"LICENSE","doc":"The MIT License (MIT)\n\nCopyright (c) 2018 Stefano Gessa\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in\nall copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\nTHE SOFTWARE.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}